"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var FormErrors_1 = __importDefault(require("../FormErrors"));
var isFunction_1 = __importDefault(require("lodash/isFunction"));
var use_input_1 = __importDefault(require("../../hooks/use-input"));
function Input(props) {
    var _a = use_input_1.default({
        name: props.name,
        getValueFromEvent: function (e) {
            return isFunction_1.default(props.mask) ? props.mask(e.target.value) : e.target.value;
        },
        defaultValue: "",
        form: props.form,
        validations: props.validations
    }), id = _a[0], dirty = _a[1], currentValue = _a[2], errors = _a[3], onChange = _a[4], validating = _a[5];
    return (react_1.default.createElement("div", { className: "input-wrapper " + (validating ? "validating" : "") },
        props.label ? react_1.default.createElement("label", { htmlFor: id }, props.label) : null,
        react_1.default.createElement("input", { type: props.type, value: currentValue, onChange: onChange, placeholder: props.placeholder, pattern: props.pattern, autoFocus: props.autoFocus, onBlur: props.onBlur }),
        props.helper ? (react_1.default.createElement("small", { className: "helper-text", dangerouslySetInnerHTML: { __html: props.helper } })) : null,
        react_1.default.createElement(FormErrors_1.default, { errors: dirty ? errors : [] })));
}
exports.default = Input;
