import Observer from "fast-observer";
import { Validation, InputMode, Values } from "./types";
/**
 *
 * Form is a singleton which gets passed into an <Input />. It holds realtime
 * data on all errors and values within a collections of inputs.
 */
export default class Form {
    observer: Observer;
    private initialValues;
    private inputValidations;
    private values;
    private errors;
    private forceCheck;
    constructor(initialValues?: Values);
    inputMode(inputName: string): InputMode;
    setInitialValues(values: Values): this;
    setValues(values: Values): this;
    forceValidations(): Promise<this>;
    validate(inputName: string): Promise<string[]>;
    setValue(inputName: string, value: any): void;
    setInitialValue(inputName: string, value: any): void;
    setErrors(inputName: string, value: string[]): void;
    getValue(inputName: string): any;
    getValues(): Values;
    getErrors(inputName: string): string[];
    setValidations(inputName: string, validations: Validation[]): void;
    hasErrors(): boolean;
}
