"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var types_1 = require("../types");
/**
 * Provide an input everything it needs.
 */
function useInput(_a) {
    var _this = this;
    var getValueFromEvent = _a.getValueFromEvent, defaultValue = _a.defaultValue, form = _a.form, name = _a.name, validations = _a.validations;
    var id = react_1.useRef("input--" + name).current;
    var _b = react_1.useState(form.getValue(name) === undefined ? defaultValue : form.getValue(name)), currentValue = _b[0], setCurrentValue = _b[1];
    var _c = react_1.useState(false), validating = _c[0], setValidating = _c[1];
    var _d = react_1.useState([]), errors = _d[0], setErrors = _d[1];
    react_1.useEffect(function () {
        if (validations) {
            form.setValidations(name, validations);
        }
        form.observer.subscribeFast(name + ".setValue", function (v) {
            form.setValue(name, v);
            setCurrentValue(v);
        });
        form.observer.subscribeFast(name + ".setInitialValue", function (v) {
            form.setValue(name, v);
            form.setInitialValue(name, v);
            setCurrentValue(v);
        });
        form.observer.subscribeFast(name + ".validate", function () { return __awaiter(_this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        setValidating(true);
                        _a = setErrors;
                        return [4 /*yield*/, form.validate(name)];
                    case 1:
                        _a.apply(void 0, [_b.sent()]);
                        setValidating(false);
                        return [2 /*return*/];
                }
            });
        }); });
        form.observer.subscribeFast("clear", function () { return setCurrentValue(""); });
        return function () {
            form.observer.unsubscribeFast(name + ".setInitialValue");
            form.observer.unsubscribeFast(name + ".setValue");
            form.observer.unsubscribeFast(name + ".validate");
            form.observer.unsubscribeFast("clear");
        };
    }, []);
    var dirty = form.inputMode(name) === types_1.InputMode.Dirty;
    function onChange(event) {
        form.observer.publishFast(name + ".setValue", getValueFromEvent(event));
        form.observer.publishFast(name + ".validate");
    }
    return [id, dirty, currentValue, errors, onChange, validating];
}
exports.default = useInput;
