export declare abstract class FormController {
}
export declare enum InputMode {
    Unstable = 0,
    Clean = 1,
    Dirty = 2
}
export declare type SubmitHander = (values: any) => Promise<void>;
export interface Validation {
    isValid: (v: any) => boolean | Promise<boolean>;
    ifNotMessage: string;
}
export declare type ValidationFn = (message?: string) => Validation;
export interface BaseInputProps<T> {
    name: string;
    form: T;
    validations?: Validation[];
    label?: string;
    helper?: string;
    disabled?: boolean;
}
export declare type Values = {
    [inputName: string]: any;
};
export declare type Errors = {
    [inputName: string]: string[];
};
export declare type InputValidations = {
    [inputName: string]: Validation[];
};
export declare type InputHookProps<T> = {
    getValueFromEvent: (event: any) => any;
    defaultValue: any;
    form: T;
    name: string;
    validations?: Validation[];
};
